=== modified file 'bzrlib/index.py'
--- bzrlib/index.py	2007-07-27 05:46:46 +0000
+++ bzrlib/index.py	2007-07-27 05:55:46 +0000
@@ -255,6 +255,7 @@
                 self._nodes[key] = (value, tuple(node_refs))
             else:
                 self._nodes[key] = value
+        self._keys = set(self._nodes)
         if trailers != 1:
             # there must be one line - the empty trailer line.
             raise errors.BadIndexData(self)
@@ -302,7 +303,7 @@
             return
         if self._nodes is None:
             self._buffer_all()
-        keys = keys.intersection(self._nodes)
+        keys = keys.intersection(self._keys)
         if self.node_ref_lists:
             for key in keys:
                 value, node_refs = self._nodes[key]

